/*
 *	main.c
 *
 *	SPC Player V2
 *
 *	* Sun Oct 17 00:00:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	/* MMC̏B */
	//mmc = mmcInit(MMC_FILESIZE_MAX); /* 21KB炢܂ */
	//ߖ̂߁ASPCt@CɕKvȃTCYɕύX
	mmc = (mmcInit(MAX_SPCSIZE) == 1); /* 700B炢܂ */

	/* t@CXg쐬܂B */
	init_file_list();
	if(!file_count) {
		err_disp("SPCt@C܂");
		exit(0);
	}

	/* Ԃ"t~"łB */
	curplay = -1;

	/* Ԃ"I[g[h"łB */
	automode = 1;
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
	/* MMC̏IB */
	if(mmc) {
		mmcExit();
	}

#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int x;
	int y;
	int len;
	va_list ap;
	char str[100]; /* ꂮ炢Ώ[H */

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
	schedule(); /* gK̂Ă邽 */
}

/****************************************************************************
 *	init_file_list
 ****************************************************************************/

static int
file_compare(const void* _a, const void* _b)
{
	FILEITEM* a = (FILEITEM*)_a;
	FILEITEM* b = (FILEITEM*)_b;
	//
	int retval;

	retval = strcasecmp(a->zip, b->zip);
	if(!retval) {
		retval = strcasecmp(a->fname, b->fname);
	}

	return retval;
}

void
init_file_list()
{
	int retval;
	int len;
	int size;
	const void* romp;
	FILEINFO fi;
	PUNZIP zip;
	PUNZIPDIR dir;

	/* ܂NAB */
	memset(file_list, 0, sizeof file_list);
	file_count = 0;

	/*** tbV ***/

	/* et@Cɂ... */
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(file_count < MAX_FILES) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */

		/* SPCt@CȂ... */
		len = strlen(fi.filename);
		if((len >= 4) && (strcasecmp(&fi.filename[len - 4], ".spc") == 0)) {
			if(len > sizeof file_list[file_count].fname - 1) continue;

			/* i[܂B */
			strcpy(file_list[file_count].fname, fi.filename);
			file_list[file_count].time = -1;
			file_count++;

			goto L_NEXT;
		}

		/* ZIPt@CȂ... */
		len = strlen(fi.filename);
		if((len >= 4) && (strcasecmp(&fi.filename[len - 4], ".zip") == 0)) {
			if(len > sizeof file_list[file_count].zip - 1) continue;

			/* ZIPt@CtbVŐ񂵂܂B */
			romp = mmap(fi.filename, &size, 1/*DEFRAG*/);
			if(!romp) continue;

			/* ZIPt@CJ܂B */
			retval = punzip_init(&zip, romp, size);
			if(retval != 0) continue;

			/* ZIP̊et@Cɂ... */
			while(punzip_dir(&zip, &dir) == 0) {
				/* SPCt@CȂ... */
				len = strlen(dir.filename);
				if((len >= 4) && (strcasecmp(&dir.filename[len - 4], ".spc") == 0)) {
					if(len > sizeof file_list[file_count].fname - 1) continue;

					/* i[܂B */
					strcpy(file_list[file_count].zip, fi.filename);
					strcpy(file_list[file_count].fname, dir.filename);
					file_list[file_count].time = -1;
					file_count++;
				}
			}

			goto L_NEXT;
		}
L_NEXT:
	}

	/*** MMC ***/

	/* MMCLȂ... */
	if(mmc) {
		/* et@Cɂ... */
		retval = mmcFileFindOpen(&fi);
		if(retval == 0) {
			while(file_count < MAX_FILES) {
				retval = mmcFileFindNext(&fi);
				if(!retval) break; /* t@CȂ */

				/* SPCt@CȂ... */
				len = strlen(fi.filename);
				if((len >= 4) && (strcasecmp(&fi.filename[len - 4], ".spc") == 0)) {
					if(len > sizeof file_list[file_count].fname - 1) continue;

					/* i[܂B */
					strcpy(file_list[file_count].zip, ".mmc"); /* ZIP".mmc"MMC\Ƃɂ܂ */
					strcpy(file_list[file_count].fname, fi.filename);
					file_list[file_count].time = -1;
					file_count++;
				}
			}
		}
	}

	/* ZIPAt@CɃ\[gB */
	qsort(file_list, file_count, sizeof(FILEITEM), file_compare);
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

static const char*
time_str(char str[/*5+1*/], int sec)
{
	int mm;
	int ss;

	if(sec >= 0) {
		mm = sec / 60;
		ss = sec % 60;
		if(mm > 99) mm = 99;
		sprintf(str, "%02d:%02d", mm, ss);
	} else {
		strcpy(str, "--:--");
	}

	return str;
}

void
app_main()
{
	int i;
	int x;
	int y;
	int c;
	int i_file;
	FILEITEM* item;
	char str1[32];
	char str2[32];

	/* Ô߁AgK̂Ă܂B */
	schedule();

	for(;;) {
		schedule();

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(curplay == -1) { /* ~̂ */
			if(joy & TRG_UP && cursel > 0             ) cursel--;
			if(joy & TRG_DN && cursel < file_count - 1) cursel++;
			if(joy & TRG_LF) {
				cursel -= MAX_DISP;
				if(cursel < 0) cursel = 0;
			}
			if(joy & TRG_RI) {
				cursel += MAX_DISP;
				if(cursel > file_count - 1) cursel = file_count - 1;
			}
		}

		/* ȑ? */
		if(curplay != -1) {
			pceAppActiveResponse(AAR_ACTIVE);

			curtime = pceTimerGetCount();
			playtime = curtime - starttime;
			if(automode) {
				if(playtime > spc_inf.play_time * 1000) {
					i = playtime - spc_inf.play_time * 1000;
					//if(i <= spc_inf.fade_time) {
					//spc_inf.fade_time=0̎Ƀ[ZȂ悤ɕύX
					if(i < spc_inf.fade_time) {
						//pceWaveSetChAtt(127 * i / spc_inf.fade_time);
						//dl0`127ƂȂĂ܂A64`127͖łB
						pceWaveSetChAtt(0, 63 * i / spc_inf.fade_time);
					} else {
						goto PLAY_NEXT;
					}
				}
			}
			if(joy & (TRG_LF | TRG_UP)) {
				cursel = cursel > 0 ? cursel - 1 : file_count - 1;
				goto DO_PLAY;
			}
			if(joy & (TRG_RI | TRG_DN)) {
PLAY_NEXT:			cursel = cursel < file_count - 1 ? cursel + 1 : 0;
				goto DO_PLAY;
			}
		}

		/* ĐJnH */
		if(joy & TRG_A) {
DO_PLAY:		render_string(&render, 1, DISP_Y - 6, "NOW LOADING...", 0x82, 0);
			schedule();
			do_play();
			if(curplay == -1) {
				err_disp("Đł܂ł");
				/* p */
			}
		}

		/* Đ~H */
		if(joy & TRG_B) {
			if(curplay != -1) {
				spc2_stop();
				curplay = -1;
			} else {
				/* ~B{^̓I[g[hؑցB */
				automode = !automode;
			}
		}

		/* ŏiɕ\t@CCfNXĒB */
		if(cursel < curtop                 ) curtop = cursel                 ;
		if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);

		/* t@CXg\B */
		memset(vbuff, 0, sizeof vbuff);
		y = 9;
		for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
			i_file = curtop + i;
			if(i_file > file_count - 1) break;
			item = &file_list[i_file];
			if(i_file == cursel) {
				if(i_file == curplay) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 1);
					c = 3;
				} else {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
					c = 0;
				}
			} else {
				if(i_file == curplay) {
					c = 3;
				} else {
					c = 2;
				}
			}
			x = 4;
			render_printf(&render, x, y, 0x82, c, "%.24s", item->fname);
			x = DISP_X - 4 * 6 + 1;
			render_printf(&render, x, y, 0x82, c, "%s", time_str(str1, item->time));
			item++;
			y += 6;
		}

		/* wb_\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 2, 3);
		render_string(&render, 0, 1,
		//       01234567890123456789012345678901
			"========== SPC Player ==========",
			0x82, 0);
		/* tb^\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, DISP_Y - (6 + 1), DISP_X, 6 + 1, 3);
		render_string(&render, 0, DISP_Y - 6,
		//       01234567890123456789012345678901
			"                            AUTO",
			0x82, automode ? 0 : 2);
		if(curplay != -1) { /* tȂSPCt@C\ */
			x = 0;
			y = 24;
			render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 * 7 + 1, 3);
			render_printf(&render, x +  4, y, 0x82, 0, "Game    :%s", spc_inf.game_title); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Song    :%s", spc_inf.song_title); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Artist  :%s", spc_inf.artist    ); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Dumper  :%s", spc_inf.dumper    ); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Comments:%s", spc_inf.comments  ); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Date    :%s", spc_inf.date      ); y += 6;
			if(automode) {
				render_printf(&render, x +  4, y, 0x82, 0, "Time    :%s/%s",
					time_str(str1, playtime / 1000),
					time_str(str2, spc_inf.play_time + spc_inf.fade_time / 1000));
			} else {
				render_printf(&render, x +  4, y, 0x82, 0, "Time    :%s",
					time_str(str1, playtime / 1000));
			}
		}
	}
}

/****************************************************************************
 *	do_play
 ****************************************************************************/

void
do_play()
{
	int retval;
	int n;
	int sct;
	int size;
	const void* romp;
	FILEITEM* item;
	FILE* fp;
	PUNZIP zip;
	FILEACC fa;

	/* ܂Amɒ~܂B */
	spc2_stop();
	curplay = -1; /* ~}[N */
	memset(spc_data, 0, sizeof spc_data); /* Ô */
	pceWaveSetChAtt(0, 0); /* tF[hAEg */

	/* SPCf[^ǂݍ݂܂B */
	if(cursel < 0 || cursel > file_count - 1) DIE(); /* 肦ȂBoO */
	item = &file_list[cursel];
	if(strcmp(item->zip, ".mmc") == 0) { /* MMCSPCt@C */
		retval = mmcFileOpen(&fa, item->fname, FOMD_RD);
		if(retval != 0) return;
		if(fa.fsize > sizeof spc_data) return; /* t@CTCY */
		size = fa.fsize;
		sct = 0;
		while(size) {
			n = size;
			if(n > BLOCKSIZE) n = BLOCKSIZE;
			retval = mmcFileReadSct(&fa, &spc_data[sct * BLOCKSIZE], sct, n);
			if(retval != n) break; /* ǂݍ݃G[? */
			size -= n;
			sct++;
		}
		mmcFileClose(&fa);
		if(size) return; /* ǂݍݓrŎsASɓǂݍ߂Ȃ */
	} else if(strcmp(item->zip, "") == 0) { /* tbVSPCt@C */
		fp = fopen(item->fname, "rb");
		if(!fp) return; /* t@C? (ۂ͂肦Ȃ) */
		retval = fread(spc_data, 1, sizeof spc_data, fp);
		fclose(fp);
		if(retval <= 0) return; /* sSPCt@C? */
	} else { /* tbVZIPt@C */
		romp = mmap(item->zip, &size, 1/*DEFRAG*/);
		if(!romp) return; /* t@C? (ۂ͂肦Ȃ) */
		retval = punzip_init(&zip, romp, size);
		if(retval != 0) return; /* t@Cꂽ?  (ۂ͂肦Ȃ)*/
		retval = punzip_uncompress(&zip, item->fname, spc_data, sizeof spc_data);
		if(retval <= 0) return; /* t@Cꂽ? (ۂ͂肦Ȃ) */
	}

	/* SPC擾B */
	retval = spc2_inf(spc_data, &spc_inf);
	if(retval != 0) return; /* sSPCt@C? */
	if(spc_inf.play_time <= 0) {
		/* K艉tԂ5Ƃ܂ */
		spc_inf.play_time = 5 * 60 - 5;	/* 5-5b */
		spc_inf.fade_time = 5 * 1000;	/*     5b */
	}
	if(spc_inf.fade_time < 0) { /* Ô */
		spc_inf.fade_time = 0;
	}

	/* ĐJnB */
	retval = spc2_play(spc_data);
	if(retval != 0) return; /* sSPCt@C? */
	curplay = cursel; /* Đ}[N */

	/* t@CXgɂtԂi[B */
	item->time = spc_inf.play_time + spc_inf.fade_time / 1000;

	/* ĐJni[B */
	starttime = pceTimerGetCount();
	curtime = starttime;
	playtime = 0;
}

